package cn.com.qmth.stmms.admin.dto;

import java.math.BigDecimal;
import java.math.RoundingMode;
import java.text.DecimalFormat;

import cn.com.qmth.stmms.biz.report.model.ReportSubjectTeacher;
import cn.com.qmth.stmms.common.annotation.ExcelField;

/**
 * 课程总评成绩分析
 */
public class ReportSubjectTeacherDTO {

    /**
     * 课程编号
     */
    @ExcelField(title = "课程代码", align = 2, sort = 10)
    private String subjectCode;

    /**
     * 课程名称
     */
    @ExcelField(title = "课程名称", align = 2, sort = 20)
    private String subjectName;

    /**
     * 教师
     */
    @ExcelField(title = "总评", align = 2, sort = 30)
    private String teacherName;

    /**
     * 最高分
     */
    @ExcelField(title = "最高分", align = 2, sort = 40)
    private String maxScore;

    /**
     * 最低分
     */
    @ExcelField(title = "最低分", align = 2, sort = 50)
    private String minScore;

    /**
     * 及格人数
     */
    @ExcelField(title = "及格人数", align = 2, sort = 60)
    private int passCount;

    /**
     * 及格率
     */
    @ExcelField(title = "及格率", align = 2, sort = 70)
    private String passRate;

    /**
     * 优秀数
     */
    @ExcelField(title = "优秀人数", align = 2, sort = 80)
    private int excellentCount;

    /**
     * 优秀率
     */
    @ExcelField(title = "优秀率", align = 2, sort = 90)
    private String excellentRate;

    /**
     * 平均分
     */
    @ExcelField(title = "平均分", align = 2, sort = 100)
    private String avgScore;

    /**
     * 平均相对分
     */
    @ExcelField(title = "平均相对分", align = 2, sort = 110)
    private String relativeAvgScore;

    /**
     * 报考人数
     */
    @ExcelField(title = "报考人数", align = 2, sort = 120)
    private Integer totalCount;

    /**
     * 有效人数
     */
    @ExcelField(title = "有效人数", align = 2, sort = 130)
    private Integer realityCount;

    public ReportSubjectTeacherDTO(ReportSubjectTeacher r) {
        DecimalFormat format = new DecimalFormat("####.###");
        this.subjectCode = r.getSubjectCode();
        this.subjectName = r.getSubjectName();
        this.teacherName = r.getTeacherName();
        this.maxScore = format.format(new BigDecimal(r.getMaxScore()).setScale(2, RoundingMode.HALF_UP).toString());
        this.minScore = format.format(new BigDecimal(r.getMinScore()).setScale(2, RoundingMode.HALF_UP).toString());
        this.avgScore = format.format(new BigDecimal(r.getAvgScore()).setScale(2, RoundingMode.HALF_UP).toString());
        this.passRate = format.format(new BigDecimal(r.getPassRate()).setScale(2, RoundingMode.HALF_UP).toString());
        this.excellentRate = format.format(new BigDecimal(r.getExcellentRate()).setScale(2, RoundingMode.HALF_UP).toString());
        this.relativeAvgScore = format.format(new BigDecimal(r.getRelativeAvgScore()).setScale(2, RoundingMode.HALF_UP).toString());
        this.passCount = r.getPassCount();
        this.excellentCount = r.getExcellentCount();
        this.realityCount = r.getRealityCount();
        this.totalCount = r.getTotalCount();
    }

    public String getSubjectCode() {
        return subjectCode;
    }

    public void setSubjectCode(String subjectCode) {
        this.subjectCode = subjectCode;
    }

    public String getSubjectName() {
        return subjectName;
    }

    public void setSubjectName(String subjectName) {
        this.subjectName = subjectName;
    }

    public String getTeacherName() {
        return teacherName;
    }

    public void setTeacherName(String teacherName) {
        this.teacherName = teacherName;
    }

    public String getMaxScore() {
        return maxScore;
    }

    public void setMaxScore(String maxScore) {
        this.maxScore = maxScore;
    }

    public String getMinScore() {
        return minScore;
    }

    public void setMinScore(String minScore) {
        this.minScore = minScore;
    }

    public int getPassCount() {
        return passCount;
    }

    public void setPassCount(int passCount) {
        this.passCount = passCount;
    }

    public String getPassRate() {
        return passRate;
    }

    public void setPassRate(String passRate) {
        this.passRate = passRate;
    }

    public int getExcellentCount() {
        return excellentCount;
    }

    public void setExcellentCount(int excellentCount) {
        this.excellentCount = excellentCount;
    }

    public String getExcellentRate() {
        return excellentRate;
    }

    public void setExcellentRate(String excellentRate) {
        this.excellentRate = excellentRate;
    }

    public String getAvgScore() {
        return avgScore;
    }

    public void setAvgScore(String avgScore) {
        this.avgScore = avgScore;
    }

    public String getRelativeAvgScore() {
        return relativeAvgScore;
    }

    public void setRelativeAvgScore(String relativeAvgScore) {
        this.relativeAvgScore = relativeAvgScore;
    }

    public Integer getTotalCount() {
        return totalCount;
    }

    public void setTotalCount(Integer totalCount) {
        this.totalCount = totalCount;
    }

    public Integer getRealityCount() {
        return realityCount;
    }

    public void setRealityCount(Integer realityCount) {
        this.realityCount = realityCount;
    }
}